# Description: This script reads a genome from standard input, separates it
#              into individual files for each chromosome. The genome must
#              be of the format: >chr1 ...

# Contact: wanja.kassuhn@web.de

# imports
import fileinput
import sys
import os.path

# init
directory='./'
out=''
skip=0
list=[]

# read file from stdin
for line in fileinput.input():
    
    # select headers
    if line.startswith(">"):
        
        # create a chromosome and a file name 
        chrom = line.split(" ")
        name = chrom[0][1:]
        out=directory + name + ".fa"

        # create and open file if its not existing already
        # write header to it
        # skip sequences with other headers than chr*
        if name.startswith("chr"):
            if os.path.isfile(out):
                output.write(">" + name + "\n")
            else:
                output=open(out,'w')
                list.append(out)
                output.write(">" + name + "\n")
        else:
            skip=1
    
    # write sequences to files
    else:
        if skip == 0:
            output.write(line)
        else:
            continue

exit