# Description: This script changes the order of the exon coordinates
#              by their rank in an fasta file (transcriptome). This
#              script needs to be used only once per transcriptome.

# Contact: wanja.kassuhn@web.de

# import
import sys
import time
import os
import fileinput

out="./transcripts_final.fasta"
newfasta = os.open(out , os.O_CREAT | os.O_WRONLY )

# take time
time0= time.time()

# iterate over transcriptome
for line in fileinput.input():
	
		if line.startswith('>'):
			
				# split original header
				vec=line.split("|")
				helper="chr"+vec[2]
				col= ":"
				
				# 
				rank=vec[7].split(";")
				numExon=len(rank)
				#rank[numExon -1]=rank[numExon -1]
				
				# get Exon start and stop ( different amount per gene ) from header
				exonstart=vec[5].split(";")
				exonend=vec[6].split(";")
				
				# create new arrays
				exonstart_sort=[]
				exonend_sort=[]
				
				# sort coordinates by exon rank
				for i in range(numExon):
					try:
						index=rank.index(str(i +1))
						exonstart_sort.append(exonstart[index])
						exonend_sort.append(exonend[index])
					except:
						#sys.stderr("ERROR: %s is invoking this error massage."  % rank )
						break
						

				coords=""
				for i in range(numExon):
					try:
						coords += col + exonstart_sort[i] + col + exonend_sort[i]
					except:
						continue
					
				# format the new header so that fimo understands	
				newline= vec[0]+"|"+vec[1] + col + vec[3] + col + vec[4] + col + helper + col + vec[8][:-1] + coords + "\n"
				os.write(newfasta , newline)
		else:
			os.write(newfasta , line)

# print time
print("--- %s min ---" % ((time.time() - time0) /60))

# close file			
os.close(newfasta)
exit