# Description: This script reads in an bed and its corresponding fasta
#              file. It extracts the alignment position of the reads
#              from the bed file and adds it to the end of the read id
#              in the fasta file.

# Contact: wanja.kassuhn@web.de

# import
import sys
import os

# init
reads={}
select=False

# open bed file
bed = open(sys.argv[1], 'r')

# iterate over bed file
for line in bed:
    
    # if line is not empty
    if not line in ['\n', '\r\n']:
        try:
            # split bed file line
            sep = line.split("\t")
            header = sep[3].split(":")
            
            # select only reads from sense strand
            if not header[7] == "A":
                # order coordinates
                start = min(int(sep[1]),int(sep[2]))
                end = max(int(sep[1]),int(sep[2]))
                c = header[1][-1:]
                
                readcoordinates = ":" + str(start) + "-" + str(end) + c
                
                reads[sep[3]] = readcoordinates
                
                #debugging
                #print sep[3] + "\t" + readcoordinates
                                
        
        # encounter an error            
        except IndexError:
            #print "# ERROR: The following line invoked an IndexError."
            #print "# " + line[:-1]
            pass
            
bed.close()

# open sequence file
fasta = open(sys.argv[2], 'r')

# iterate over file and print reads and sequences corresponding headers in dictionary
for line in fasta:
    if line.startswith(">"):
        if line[1:-1] in reads:
            
            print line[:-1] + reads[line[1:-1]]
            select=True
            
    else:
        if select:
            print line[:-1]
            select=False
        else:
            continue

# clear dictionary and close files
reads.clear()
fasta.close()
         
exit