# Description: This script reads in a index file and a flux expression
#              profile. It will set the expression of all transcripts
#              that are not in the index file to 0.             

# Contact: wanja.kassuhn@web.de

# imports
import sys
from math import ceil

# init 
motifs = {}
sumWO=0
sumW=0

# open index file
index = open(sys.argv[1], 'r')

# iterate index file
for line in index:
    
    # skip head line and empty
    if not line.startswith('#') and not line in ['\n', '\r\n']:
        
        # split line
        sep = line.split('\t')
        
        # extract transcript ID
        transcriptID = sep[1].split('|')[1]

        # only add transcript IDs once to the dictionary
        if not transcriptID in motifs:
            
            # fill dictionary with transcript IDs
            motifs[transcriptID] = ""

# close index file
index.close()

# open expression profile
profile = open(sys.argv[2], 'r')

for line in profile:
    sep = line[:-1].split('\t')
    if sep[1].split('.')[0] in motifs:
        sumW+=int(sep[5])
    else:
        sumWO+=int(sep[5])

if not sumW == 0:       
    multiplier = float((sumW+sumWO))/float(sumW)
else:
    multiplier = 1

profile.close()
profile = open(sys.argv[2], 'r')

# iterate expression profile     
for line in profile:
    
    # split line 
    sep = line[:-1].split('\t')
    
    # extract transcript ID
    
    transcriptID = sep[1].split('.')[0]

    # if transcript has no motif set expression to 0
    if not transcriptID in motifs:
        
        if len(sep) == 8:
            sep[4]="0.0"
            sep[5]="0"
            sep[6]="0.0"
            sep[7]="0\n"
        else:
            sep[4]="0.0"
            sep[5]="0"
            sep.append("0.0")
            sep.append("0\n")
        
        for entry in range(len(sep)-1):
            sys.stdout.write("%s\t" % sep[entry])
        sys.stdout.write("%s" % sep[len(sep)-1])
        
    elif sep[4] == "0.0" and  sep[5] == "0":
        
        print line[:-1]
    
    # multiply expression   
    else:
        sep[5] = str(int(ceil(float(sep[5]) * multiplier)))
        
        
        for i in range(len(sep)-1):
            sys.stdout.write("%s\t" % sep[i])
        sys.stdout.write("%s\n" % sep[len(sep)-1])
        
# close expression profile       
profile.close()

# empty dictionary
motifs.clear()

exit